1 REMark Spinning disks by Per Witte - runs on SBASIC - GD2 only
2 :
3 rem V0.01 January 27th 2004
4 :
5 rem                     Variables
6 :
7 count% = 300:           rem Number of objects
8 acc = 1/5:           rem Overall acceleration
9 cx = 50: cy = 50:       rem Centre
10 chc = 1:                rem Change background colour switch
11 :
12 dim sx(count%):         rem Start position x
13 dim sy(count%):         rem Start position y
14 dim svx(count%):        rem Start velocity x
15 dim svy(count%):        rem Start velocity y
16 dim rd(count%):         rem Start radius
17 dim sax(count%):        rem Acceleration x
18 dim say(count%):        rem Acceleration y
19 dim col(count%):        rem Colour
20 dim ec(count%):         rem Eccentricity
21 dim ang(count%):        rem Angle
22 dim trn(count%):        rem Turn
23 dim grw(count%):        rem Grow
24 dim fill%(count%):      rem Fill
25 :
26 rem br% = rnd(0 to 255): bg% = rnd(0 to 255): bb% = rnd(0 to 255)
27 ir% = 1: ig% = 1: ib% = 1
28 if chc then
29  bgc = hex(hex$(RND * 255, 8) & hex$(rnd * 255, 8) & hex$(rnd * 255, 8))
30  ir% = rnd(1 to 24): ig% = rnd(1 to 24): ib% = rnd (1 to 24)
31 else
32  bgc = 0
33 endif
34 pi2 = pi * 2
35 :
36 rem                     Init
37 :
38 dc = FOPEN("con_"): ERT dc
39 WINDOW#dc; SCR_XLIM(#dc), SCR_YLIM(#dc), 0, 0
40 rem CLS#dc
41 colour_24
42 RANDOMISE DATE
43 FOR i% = 0 TO count%: MakeObj(i%)
44 :
45 rem                     Program loop
46 REPeat main
47   Animate
48   IF CODE(INKEY$(#dc; 0)) = 27: EXIT main
49 END REPeat main
50 :
51 CLOSE#dc: QUIT
52 :
53 DEFine PROCedure MakeObj(n%)
54 a = RND * pi2
55 :
56 rem             Set size of object (radius)
57 rep ll: rd(n%) = rnd / 5: if rd(n%) > 0: exit ll
58 :
59 rem             Set acceleration
60 sax(n%) = acc * cos(a) / rd(n%) / rnd(20 to 200)
61 say(n%) = acc * sin(a) / rd(n%) / rnd(20 to 200)
62 :
63 rem             Set velocity & direction
64 svx(n%) = cos(a) * rnd
65 svy(n%) = sin(a) * rnd
66 :
67 rem             Set start position
68 sx(n%) = cx + svx(n%) + sax(n%)
69 sy(n%) = cy + svy(n%) + say(n%)
70 :
71 rem             Set remaining parameters
72 sel on rnd(0 to 9): = 0 to 6: ec(n%) = 1: = remainder: ec(n%) = rnd * 4
73 ang(n%) = rnd(-90 to 90) * pi / 100
74 if ec(n%) > 0 then
75  trn(n%) = rnd / rd(n%) / ec(n%)
76 else
77  trn(n%) = 0
78 endif
79 grw(n%) = (abs(svx(n%)) + abs(svy(n%))) * rd(n%) / 5
80 sel on rnd * 255: = 1 to 25: fill%(n%) = 1: = remainder: fill%(n%) = 0
81 rep cl
82  col(n%) = hex(hex$(RND * 255, 8) & hex$(rnd * 255, 8) & hex$(rnd * 255, 8))
83  if abs(col(n%)) > 15: exit cl
84 endrep cl
85 END DEFine
86 :
87 DEFine PROCedure Animate
88 FOR i% = 0 TO count%
89  INK#dc; bgc
90  fill#dc; fill%(i%)
91  circle#dc; sx(i%), sy(i%), rd(i%), ec(i%), ang(i%)
92  :
93  ang(i%) = ang(i%) + trn(i%)
94  sx(i%) = sx(i%) + svx(i%)
95  sy(i%) = sy(i%) + svy(i%)
96  svx(i%) = svx(i%) + sax(i%)
97  svy(i%) = svy(i%) + say(i%)
98  rd(i%) = rd(i%) + grw(i%)
99  IF sx(i%) < 0 OR sx(i%) > 100 OR sy(i%) < 0 OR sy(i%) > 100 THEN
100   MakeObj(i%)
101  ELSE
102   INK#dc; col(i%)
103   fill#dc; fill%(i%)
104   circle#dc; sx(i%), sy(i%), rd(i%), ec(i%), ang(i%)
105  END IF
106 END FOR i%
107 if chc then
108  bgc = hex(hex$(br%, 8) & hex$(bg%, 8) & hex$(bb%, 8))
109  bb% = bb% + ib%: bg% = bg% + ig%: br% = br% + ir%
110  if bb% > 255 then
111   ib% = rnd(-24 to -1)
112  else
113   if bb% < 0: ib% = rnd(0 to 24)
114  endif
115  if bg% > 255 then
116   ig% = rnd(-24 to -1)
117  else
118   if bg% < 0: ig% = rnd(0 to 24)
119  endif
120  if br% > 255 then
121   ir% = rnd(-24 to -1)
122  else
123   if br% < 0: ir% = rnd(1 to 24)
124  endif
125  at#dc; 0, 0: ink#dc; $ffffff: strip#dc; 0: print#dc; hex$(br%, 8)! hex$(bg%, 8)! hex$(bb%, 8)
126 endif
127 END DEFine
128 :
